// Output generated from file: C:/install/my/Fragmentarium/Examples/sky/sky_/test.frag
// Created:  5.  16:12:29 2017
// Output generated from file: C:/install/my/Fragmentarium/Examples/sky/Menger.frag
// Created:  5.  15:00:11 2017
#version 400 compatibility
//#version 400
#define WANGHASH
#define USE_TEXTURE
//#version 120
//#define OLD_FRAG

#include "MathUtils.frag"
//#include "newIQPath.frag"
//#include "iqPath_Light.frag"
#include "Sky-PathTracer.frag"


#group Menger
uniform int Iterations;  slider[0,8,100]
uniform float Scale; slider[0.00,3.0,4.00]
uniform vec3 Offset; slider[(0,0,0),(1,1,1),(3,3,3)]
uniform bool Use_Floor; checkbox[false]
uniform int ColorIterations;  slider[0,2,100]

float DE(vec3 z)
{
	float p = z.z;
	float r;
	int n = 0;
	z = abs(z);
	if (z.x<z.y){ z.xy = z.yx;}
	if (z.x<z.z){ z.xz = z.zx;}
	if (z.y<z.z){ z.yz = z.zy;}
	if (z.z<1./3.){ z.z -=2.*( z.z-1./3.);}
	while (n < Iterations && dot(z,z)<100.0) {
		z=Scale* (z-Offset)+Offset;
		z = abs(z);
		if (z.x<z.y){ z.xy = z.yx;}
		if (z.x< z.z){ z.xz = z.zx;}
		if (z.y<z.z){ z.yz = z.zy;}
		if (z.z<1./3.*Offset.z){ z.z -=2.*( z.z-1./3.*Offset.z);}
		r = dot(z-Offset, z-Offset);
if (n<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.xyz,dot(z,z))));
		n++;
	}
	//return (length(z)-sqrt(3.) ) * pow(Scale, float(-n));
	return(Use_Floor)? min(p,float(z.x-Offset) * pow(Scale, float(-n))):float(z.x-Offset) * pow(Scale, float(-n));
}





































#preset default
FOV = 0.4
Eye = -2.04556,-1.81922,1.81154
Target = 4.30935,3.57458,-3.71316
Up = 0.428882,0.349824,0.832877
Gamma = 2
ToneMapping = 2
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
turbidity = 2
sunSize = 1
SunPos = 0.24074,0.34259
SkyFactor = 2
DepthToAlpha = false
Detail = -3.84069
FudgeFactor = 1
SoftShadows = 1
MaxRaySteps = 56
BaseColor = 1,1,1
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
Reflectivity = 0.2
DebugLast = false
Stratify = false
RayDepth = 2 NotLocked
Albedo = 1
BiasedSampling = true
DirectLight = true
Iterations = 3
Scale = 3
Offset = 1,1,1
Use_Floor = false
ColorIterations = 3
FocalPlane = 0.01
Aperture = 0
InFocusAWidth = 0
ApertureNbrSides = 5
ApertureRot = 0
ApStarShaped = false
Bloom = false
BloomIntensity = 2
BloomPow = 2.3596
BloomTaps = 14
MaxDepth = 20
#endpreset

